<?php  
/* 
Plugin Name: Personal Uploads
Plugin URI: http://printf.eu/ 
Description: Ce plugin vous permet d'uploadez vos fichiers de tout genre directement sur votre hebergement de maniere privé.
Version: 0.0.1
Author: <a href="http://printf.eu/">Florian B.</a> 
Author URI: http://printf.eu 
*/

define( 'PU_PLUGIN_URL', plugins_url()."/personal_uploads/");
class PersonalUpload {
	const PERSONAL_UPLOADS_VERSION				= "0.0.1";
	const PERSONAL_UPLOADS_TABLE				= "PERSONAL_UPLOADS";
	const PERSONAL_UPLOADS_CATEGORIES_TABLE		= "PERSONAL_UPLOADS_categories";
	const PERSONAL_UPLOADS_DIRECTORY			= "uploadperso";
	
	function __construct() {
		if(!is_admin()) {
			return;
		}
		
		add_action('admin_menu', array($this,'personalUploadMenu'));
	}
	
	// action function for above hook
	function personalUploadMenu() {
	    // Ajout menu top niveau
	    add_menu_page('Personal uploads', 'Personal uploads', 8, 'all-personal-uploads', array($this,'personalUploadMainPage'),PU_PLUGIN_URL.'imgs/download.png');
	
	    // Ajout sous-menus
	    add_submenu_page('all-personal-uploads', 'New Upload', 'New Upload', 8, 'new-personal-uploads', array($this,'personalUploadAjouter'));
		add_submenu_page('all-personal-uploads', 'Categories', 'Categories', 8, 'categories-personal-uploads', array($this,'personalUploadCategories'));
	}
	
	function personalUploadMainPage() {
		global $wpdb;  
	    $table_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_TABLE;
		$table_categories_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_CATEGORIES_TABLE;
		$dossier = ABSPATH.PersonalUpload::PERSONAL_UPLOADS_DIRECTORY.'/';
		
		//cas delete
		if(isset($_GET['delete']))
		{
			try {
				unlink($dossier.$_GET['delete']);
				
				//delete de la miniature au cas où
				@unlink($dossier.'mini_'.$_GET['delete']);
				$delete_name = $_GET['delete'];
				$wpdb->query("DELETE FROM $table_name WHERE upload_name = '".$delete_name."'");
				echo '<div class="updated"><p>File has been deleted</p></div>';
			}
			catch (Exception $e) {
				echo '<div class="error"><p>An error occurred '.$e->getMessage().'</p></div>';
			}
		}
		
		if(isset($_GET['action'])) $action = $_GET['action'];
		else $action = false;
		
		if($action == "upload") {
			if(isset($_FILES['pupload']))
			{ 
				try {					
					if($_POST['name'] == "") $fichier = basename($_FILES['pupload']['name']);
					else $fichier = stripslashes($_POST['name']).strrchr($_FILES['pupload']['name'],'.');
					$upload_name = time().PersonalUpload::retireAccents($fichier);
					if(move_uploaded_file($_FILES['pupload']['tmp_name'], $dossier . $upload_name)) 
					{
						//ajout en base
						$wpdb->insert($table_name, array(  
							'id_user' => wp_get_current_user()->ID,
							'name' => $fichier,
							'upload_name' => $upload_name,
							'categorie_id' => $_POST['categorie_id'],
							'comment' => '0',
							'size' => $_FILES['pupload']['size'],
							'ip' => $_SERVER["REMOTE_ADDR"],  
							'created_at' => current_time('mysql')
						));
						
						//création de la miniature au cas où c'est une image
						$this->copier_image($dossier.$upload_name,'mini_'.$upload_name,$dossier.'mini_'.$upload_name,'140','140');
						
						echo '<div class="updated"><p>File has been uploaded</p></div>';
					}
					else //Sinon (la fonction renvoie FALSE).
					{
						echo '<div class="error"><p>The Upload Failed...</p></div>';
					}
				}
				catch (Exception $e) {
					echo '<div class="error"><p>An error occurred '.$e->getMessage().'</p></div>';
				}
			}
			else
			{
				echo '<div class="error"><p>No File to Upload...</p></div>';
			}
		}
		
		include 'files/allUploads.php';
		
		/*
		$sql = "SELECT * FROM " . $table_name;
		$results = $wpdb->get_results($sql);
		//if it returned a non empty quote we know it worked
		if(!empty($results[0]->name))
		{
			foreach ($results as $result){
				$this->afficherUpload($result);
			}
		}
		else
		{
			?>
			<div class="error"><p><strong><?php _e('Error','helpnotes'); ?></strong> : <?php _e(' You didn\'t upload any file');?></p></div>
			<?php
		}*/
	}
	
	function personalUploadAjouter() {
		global $wpdb;  
	    $table_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_TABLE;
		$table_categories_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_CATEGORIES_TABLE;
		
		include 'files/uploadForm.php';
	}
	
	function personalUploadCategories() {
		global $wpdb; 
		$table_categories_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_CATEGORIES_TABLE;

		//cas de l'edit
		if($_GET['cat_edit'] != "" && $_POST['name'] != ""){
			try {
				$wpdb->update( 
					$table_categories_name, 
					array( 
						'category_name' => $_POST['name']
					), 
					array( 'id_category' => $_GET['cat_edit'] ) 
				);
				echo '<div class="updated"><p>Category has been updated</p></div>';
			}
			catch (Exception $e) {
				echo '<div class="error"><p>An error occurred '.$e->getMessage().'</p></div>';
			}
		}
		//cas de l'ajout
		elseif($_POST['name'] != ""){
			try {
				$wpdb->insert($table_categories_name, array(  
							'category_name' => $_POST['name']
						));
				echo '<div class="updated"><p>Category has been added</p></div>';
			}
			catch (Exception $e) {
				echo '<div class="error"><p>An error occurred '.$e->getMessage().'</p></div>';
			}
		}
		
		include 'files/categories.php';
		if($_GET['cat_id'] != "") {
			include 'files/editCategories.php';
		}
		else include 'files/addCategories.php';
	}
	
	function afficherUpload($file,$cat_id){
		$dossier = ABSPATH.PersonalUpload::PERSONAL_UPLOADS_DIRECTORY.'/';
		include 'files/aUpload.php';
	}
	
	function crypter($maCleDeCryptage, $maChaineACrypter){
		$maCleDeCryptage = md5($maCleDeCryptage);
		$letter = -1;
		$newstr = '';
		$strlen = strlen($maChaineACrypter);
		for($i = 0; $i < $strlen; $i++ ){
		$letter++;
		if ( $letter > 31 ){
		$letter = 0;
		}
		$neword = ord($maChaineACrypter{$i}) + ord($maCleDeCryptage{$letter});
		if ( $neword > 255 ){
		$neword -= 256;
		}
		$newstr .= chr($neword);
		}
		return base64_encode($newstr);
	}
	
	function copier_image($photo,$nom_photo,$destination,$longueur_max,$hauteur_max)
	{
		// ----extention --------
		$ext = explode(".", $nom_photo);
		if(count($ext) > 1) $ext = strtolower(end($ext));
		if (($ext=='jpg') or ($ext=='jpeg') or ($ext=='jpe'))
		   {
			$type='jpg';
			$est_image='oui';
		   }
		else if ($ext=='gif')
		   {
			$type='gif';
			$est_image='oui';
		   }
		else if ($ext=='png')
		   {
			$type='png';
			$est_image='oui';
		   }
		else $est_image='non';

		if ($est_image=='oui')
		   {
			// ----info de l'image
			$size = GetImageSize($photo);
			if ($type=='jpg') $src_im = ImageCreateFromJpeg($photo);
			else if ($type=='gif') $src_im = ImageCreateFromGif($photo);
			else if ($type=='png') $src_im = ImageCreateFromPng($photo);
			$longueur_photo = $size[0];
			$hauteur_photo = $size[1];

			if ($longueur_photo>$hauteur_photo) { $longueur_photo=$longueur_max; $hauteur_photo=$size[1]*$longueur_max/$size[0];   } 
			elseif ($longueur_photo<$hauteur_photo){ $hauteur_photo=$hauteur_max;  $longueur_photo=$size[0]*$hauteur_max/$size[1];  }
			else {  $longueur_photo=$longueur_max;  $hauteur_photo=$hauteur_max; }
					
			$x=   ($longueur_max-$longueur_photo)/2; 
			$y=   ($hauteur_max-$hauteur_photo)/2; 

			if ($longueur_max==$hauteur_max)
			   {
			  $longueur=$longueur_max;
			  $hauteur=$hauteur_max;
			  }
		   else
			  {
			  $longueur=$longueur_photo;
			  $hauteur=$hauteur_photo;
			  $x=0;
			  $y=0;
			  }
			$dst_im = ImageCreateTrueColor($longueur,$hauteur);
			$blanc=imagecolorallocate($dst_im,255,255,255); 
			imagefill($dst_im , 0,0, $blanc);
			   
			ImageCopyResampled($dst_im,$src_im,$x,$y,0,0,$longueur_photo,$hauteur_photo,$size[0],$size[1]);
			   
			if (ImageJpeg($dst_im,$destination,95)) return true;
			else return false;
			  
	   }
	   else return false;
	}
	
	function install(){  
		global $wpdb;  
	    $table_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_TABLE;
		$table_categories_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_CATEGORIES_TABLE;
		
	    if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name)  
	    {  
	        //création de la table  
	        $sql = "CREATE TABLE `$table_name` (  
	            `id_upload` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,  
	            `id_user` BIGINT UNSIGNED NOT NULL ,
	            `name` VARCHAR( 255 ) NOT NULL ,
				`upload_name` VARCHAR( 255 ) NOT NULL ,
	            `comment` VARCHAR( 5000 ) NOT NULL ,
				`size` VARCHAR( 255 ) NOT NULL ,
	            `categorie_id` INT ( 8 ) NOT NULL ,
	            `created_at` DATETIME NOT NULL ,
	            `ip` VARCHAR( 20 ) NOT NULL  
	            ) ;";
				
			$sql .= "CREATE TABLE `$table_categories_name` (  
	            `id_category` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,  
	            `category_name` VARCHAR( 255 ) NOT NULL 
	            ) ;";
	        
			//bugfix Windows...
			if ( file_exists(ABSPATH . 'wp-admin\includes\upgrade.php') ) require_once(ABSPATH . 'wp-admin\includes\upgrade.php');
			else require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

			dbDelta($sql);
	    }
		$wpdb->insert($table_categories_name, array(  
							'category_name' => 'Default'
						));
		
		//création dossier d'uploads
		mkdir(ABSPATH.PersonalUpload::PERSONAL_UPLOADS_DIRECTORY); //ce dossier ne sera pas supprimé
		
		//on ajoute un fichier htaccess
		$htaccess = fopen (ABSPATH.PersonalUpload::PERSONAL_UPLOADS_DIRECTORY."/.htaccess", "a+");
		fwrite($htaccess, "deny from all");
		fclose($htaccess);
		
	    add_option('personal_uploads_version',PersonalUpload::PERSONAL_UPLOADS_VERSION);  
	}
	
	function uninstall(){  
	    global $wpdb;  
	    $table_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_TABLE;
		$table_categories_name = $wpdb->prefix.PersonalUpload::PERSONAL_UPLOADS_CATEGORIES_TABLE;
		
		$sql = "DROP TABLE `$table_name`";  
	    $wpdb->query($sql);
	    
		$sql = "DROP TABLE `$table_categories_name`";  
	    $wpdb->query($sql);

	    delete_option('personal_uploads_version'); 
	}
	
	function retireAccents($txt) {
	  $masque = "[?!]";
	  $txt = eregi_replace($masque, "", $txt);

	  $masque = "[àâä@]";
	  $txt = eregi_replace($masque, "a", $txt);

	  $masque = "[éèêë€]";
	  $txt = eregi_replace($masque, "e", $txt);

	  $masque = "[ïì]";
	  $txt = eregi_replace($masque, "i", $txt);

	  $masque = "[ôö]";
	  $txt = eregi_replace($masque, "o", $txt);

	  $masque = "[ùûü]";
	  $txt = eregi_replace($masque, "u", $txt);

	  $masque = "[ç]";
	  $txt = eregi_replace($masque, "c", $txt);

	  $masque = "[&]";
	  $txt = eregi_replace($masque, "et", $txt);
	  
	  $masque = "'";
	  $txt = eregi_replace($masque, "-", $txt);
	  
	  $masque = "[\]";
	  $txt = eregi_replace($masque, "", $txt);
	  
	  $masque = '"';
	  $txt = eregi_replace($masque, "-", $txt);

	  $masque = " +";
	  $txt = eregi_replace($masque, "-", $txt);

	  return(strtolower($txt));
	}
}

function personal_uploads_init_manager() {
	new PersonalUpload();
}
add_action('init','personal_uploads_init_manager', 1);


register_activation_hook( __FILE__, array('PersonalUpload', 'install') );
register_deactivation_hook( __FILE__, array('PersonalUpload', 'uninstall') );
?>